#!/usr/bin/perl -w

usage() if $#ARGV != 1;
$fn = shift @ARGV;
die "cannot read file $fn" unless -r $fn;
$input = shift @ARGV;
die "invalid input $input" unless $input =~ /^[01]*$/;
$n = length($input);
@x = split(//,$input);
for ($i = 0; $i < $n; $i++) { $dp[$i] = 0; }
$depth = $size = 0;

print "input: ",output(),"\n";
open FD,$fn;
while (<FD>) {
	tr/\015\012//d;
	die "invalid instruction $_ in $fn" unless /^(\d+) (\d+)$/;
	($a,$b) = ($1-1,$2-1);
	die "number too large w.r.t. input" if $a >= $n || $b >= $n;
	($x[$a],$x[$b]) = (min($x[$a],$x[$b]),max($x[$a],$x[$b]));
	$dp[$a] = $dp[$b] = max($dp[$a],$dp[$b])+1;
	$depth = $dp[$a] if ($depth < $dp[$a]);
	$size++;
	
	print "state after $_: ",output(),"\n";
}
close FD;

print "result: ",output(),"\n";
print "size: $size, depth: $depth\n";
exit 0;

sub usage {
	print "\nusage: sn.pl <filename> <input>\n",
		"  <filename> : contains sorting network\n",
		"  <input>    : string of 0 and 1\n\n";
	exit 2;
}

sub output {
	return join("",@x);
}

sub max {
	my ($x,$y) = @_;
	return ($x > $y)? $x : $y;
}

sub min {
	my ($x,$y) = @_;
	return ($x < $y)? $x : $y;
}
